# Lab 1 Setup 

## Introduction

In this Lab you will learn how to set up a QEMU (Quick Emulator) environment, integrate FreeRTOS
(Free Real-Time Operating System) in a baremetal system, and run a basic LED blink program on an
emulated Nucleo board.

## Prerequisites
You need a machine with a Linux distribution installed. You can use a virtual machine or a dual boot
system. The following instructions are for Debian-based distributions (e.g., Ubuntu).

## Getting Started
1. Open a terminal and Update the package list and upgrade the system:
```bash
sudo apt update
sudo apt upgrade
```
2. Install the required packages:
- Install the build-essential package:
The build-essential package contains a list of packages required for building software in general.
it includes the GNU Compiler Collection (GCC), GNU Make, and other tools. To install it, run the
following command:
```bash
sudo apt install build-essential
```
- Install the git package: The git package is a distributed version control system. This package
will be used during the course, it allows you to clone, push, and pull repositories. To install it,
run the following command:
```bash 
sudo apt install git
```

- Now you can clone the repository, you will find all the necessary files for this lab, Notice that
  you should have registered to the GitLab repository before cloning it.
```bash
git clone 
```
- [Exercise 1](./Ex1_UserEmulation/README.md)
- [Exercise 2](./Ex2_Baremetal/README.md)
- [Exercise 3](./Ex3_GDB/README.md)

